#/usr/bin/env python
import sys
sys.path.append("../tools")
import simreport
import numpy as np
import matplotlib.pyplot as plt;
from operator import itemgetter

def importdata(reports, numpart):
    ydata = []
    xdata = []
    basic = 0
    for report in reports:
        if report.numpart == numpart and report.numhandlers == 1:
            basic = report.qps
            break
    
    for report in reports:
        if report.numpart == numpart:
            ydata.append(report.qps * 1.0 / basic)
            xdata.append(report.numhandlers)
    return (xdata, ydata)

def plotpart(reports, numpart):
    (xdata, ydata) = importdata(reports, numpart)
    return (plt.plot(xdata, ydata, '-+'))

reports = simreport.importAvgReports("bench_scalability_part_1.bin")
reports.extend(simreport.importAvgReports("bench_scalability_part_2.bin"))
reports.extend(simreport.importAvgReports("bench_scalability_part_4.bin"))
reports.extend(simreport.importAvgReports("bench_scalability_part_8.bin"))

p1 = plotpart(reports, 1)
p2 = plotpart(reports, 2)
p4 = plotpart(reports, 4)
p8 = plotpart(reports, 8)
p16 = plotpart(reports, 16)

plt.ylim(1, 16)
plt.ylabel("Speedup")
plt.xlabel("# query handlers")
plt.legend((p1[0], p2[0], p4[0], p8[0], p16[0]), ('1 part', '2 part', '4 part', '8 part', '16 part'))

plt.savefig("figure_1.svg", format="svg")
