#include <pthread.h>
#include <time.h>
#include "cond.h"

namespace vsim {

Cond::Cond() : Mutex()
{
    pthread_cond_init(&_cond, NULL);
}

Cond::~Cond()
{
    pthread_cond_destroy(&_cond);
}

void
Cond::wait(void)
{
    pthread_cond_wait(&_cond, &_lock);
}

void
Cond::timedWait(unsigned long seconds)
{
    struct timespec tv;
    tv.tv_sec = seconds;
    tv.tv_nsec = 0;
    pthread_cond_timedwait(&_cond, &_lock, &tv);
}

void
Cond::notify(void)
{
    pthread_cond_signal(&_cond);
}

void
Cond::notifyAll(void)
{
    pthread_cond_broadcast(&_cond);
}

} // end vsim
