#ifndef _VSIM_COND_H_
#define _VSIM_COND_H_
#include <pthread.h>
#include "mutex.h"

namespace vsim {
/**
 * A wrapper for POSIX conditional variables, which carries an implicit mutex.
 */
class Cond : public Mutex
{
public:
    Cond();
    ~Cond();
    void wait(void);
    void timedWait(unsigned long);
    void notify(void);
    void notifyAll(void);
private:
    pthread_cond_t _cond;
};

} // end vsim
#endif
