#include <string>
#include "misc.h"

namespace vsim {

SlotDistribution
slotDistTextToEnum(const std::string &distname)
{
    if (distname.compare("poisson") == 0)
        return (POISSON);
    if (distname.compare("gauss") == 0)
        return (GAUSS);
    if (distname.compare("geometric") == 0)
        return (GEOMETRIC);
    return (BINOMIAL);
}

std::string
slotDistEnumToText(SlotDistribution dist)
{
    if (dist == POISSON)
        return ("poisson");
    if (dist == GAUSS)
        return ("gauss");
    if (dist == GEOMETRIC)
        return ("geometric");
    return ("binomial");
}

} // end vsim
