#include <pthread.h>
#include "mutex.h"

namespace vsim {

Mutex::Mutex()
{
    pthread_mutex_init(&_lock, NULL);
}

Mutex::~Mutex()
{
    pthread_mutex_destroy(&_lock);
}

void
Mutex::lock(void)
{
    pthread_mutex_lock(&_lock);
}

void
Mutex::unlock(void)
{
    pthread_mutex_unlock(&_lock);
}

} // end vsim
