#include <iostream>

#include "atomic.h"
#include "queryhandler.h"
#include "misc.h"
#include "types.h"

namespace vsim {

QueryHandler::QueryHandler(std::vector<PartitionQueue> &partitions, VSimStat &st, QueryQueue &queue) :
    _partitions(partitions),
    _queue(queue),
    _st(st),
    _done(2)
{
}

QueryHandler::~QueryHandler() { }

void
QueryHandler::run(void)
{
    bool stop = false;
    while (1) {
        Query::SP qsp = _queue.dequeue(stop);
        if (stop) {
            break;
        }
        for (partid_t i = 0; i < _partitions.size(); i++) {
            _partitions[i].enqueue(qsp);
        }
        qsp->merge();
        qsp->stopHandler();
        qsp->reportStats(_st);
    }
    _done.wait();
}

void QueryHandler::shutdown(void)
{
    _queue.shutdown();
    _done.wait();
}

} // end vsim
