#include <iostream>
#include "resultbuffer.h"
#include "hitvector.h"

namespace vsim {

void
ResultBuffer::mergeHits(partid_t part)
{
    HitVector &op(_result[_resultptr]);
    HitVector &res(_result[((_resultptr + 1) % 2)]);

    res.merge(op, _collectors[part].getResultBuffer());
    op.reset();
    _resultptr = ((_resultptr + 1) % 2);
}

void
ResultBuffer::printHits(void) const
{
    std::cout << "Complete hits: \n";
    const HitVector &result(_result[_resultptr]);
    result.printHits();
}

} // end vsim
