#include <pthread.h>
#include "spinlock.h"

namespace vsim {

SpinLock::SpinLock()
{
    pthread_spin_init(&_lock, 0);
}

SpinLock::~SpinLock()
{
    pthread_spin_destroy(&_lock);
}

void
SpinLock::lock(void)
{
    pthread_spin_lock(&_lock);
}

void
SpinLock::unlock(void)
{
    pthread_spin_unlock(&_lock);
}

} // end vsim
