#ifndef _VSIM_SPINLOCK_H_
#define _VSIM_SPINLOCK_H_
#include <pthread.h>

namespace vsim {

/**
 * A SpinLock is a wrapper around POSIX spinlocks. Synchronization primitive
 * that can be used if locks should be hold for a short period.
 */
class SpinLock {
public:
    SpinLock();
    virtual ~SpinLock();
    void lock(void);
    void unlock(void); 
protected:
    pthread_spinlock_t _lock;
};

} // end vsim

#endif
