#ifndef _VSIM_TASK_H_
#define _VSIM_TASK_H_
#include <boost/shared_ptr.hpp>
#include "query.h"

namespace vsim {

/**
 * The Task class is an interface towards a runnable entity in the Vespa
 * simulator. A class implementing this interface may be scheduled by the
 * threadpool class.
 */
class Task {
public:
    typedef boost::shared_ptr<Task> SP;
    virtual ~Task() {}

    virtual void run(void) = 0;
    virtual void shutdown(void) = 0;
    virtual bool getPreferredCPU(cpu_set_t &) = 0;
};

} // end vsim

#endif
