#include <iostream>
#include <vector>
#include <pthread.h>
#include "threadpool.h"
#include "thread.h"
#include "task.h"

namespace vsim {

ThreadPool::ThreadPool(unsigned int size) : _poolsize(size)
{
    for (unsigned int i = 0; i < _poolsize; i++) {
        Thread *t = new Thread();
        _pool.push_back(Thread::SP(t));
    }
}

ThreadPool::~ThreadPool()
{
    for (unsigned int i = 0; i < _poolsize; i++) {
        Thread &t = (*_pool.at(i));
        t.join();
    }
}

int
ThreadPool::runThread(Task::SP task)
{
    while (1) {
            for (std::vector<Thread::SP>::iterator iter = _pool.begin();
                 iter != _pool.end(); ++iter) {
                if ((*iter)->dispatch(task)) {
                    return 0;
            }
        }
    }
    std::cout << "Found no thread to dispatch!\n";
    return -1;
}

} // end vsim
