#ifndef _VSIM_THREADPOOL_H_
#define _VSIM_THREADPOOL_H_
#include <vector>
#include "task.h"
#include "thread.h"

namespace vsim {

/**
 * A ThreadPool implements a set of threads that may be assigned a task and
 * run.
 */
class ThreadPool {
public:
    ThreadPool(unsigned int);
    ~ThreadPool();
    int runThread(Task::SP);
private:
    std::vector<Thread::SP> _pool;
    unsigned int _poolsize;
};

} // end vsim

#endif
