#ifndef _VSIM_TYPES_H_
#define _VSIM_TYPES_H_
#include <boost/shared_ptr.hpp>
#include <vector>
#include <list>
#include <stdint.h>

namespace vsim {

typedef unsigned long docid_t;
typedef unsigned long partid_t;
typedef uint64_t rank_t;
typedef std::vector<docid_t> DocidVector;
typedef std::list<docid_t> DocidList;
enum VSimMode { TIMEMODE, QUERYMODE };
enum SlotDistribution { BINOMIAL, GAUSS, POISSON, GEOMETRIC };
class Slot {
public:
    Slot(docid_t f, docid_t s, double p) : first(f), second(s), prob(p) {}
    docid_t first;
    docid_t second;
    double prob;
};
typedef std::vector<Slot> PartitionRange;
typedef std::vector<PartitionRange> PartitionSpec;
typedef boost::shared_ptr<PartitionSpec> PartitionSpecSP;

typedef std::pair<docid_t, unsigned long> Hit;
typedef docid_t PartitionHit;
typedef std::vector<PartitionHit> HitStat;

typedef unsigned long attr_t;
typedef attr_t * attrptr_t;
typedef std::vector<attrptr_t> AttributeVector;
typedef std::vector<unsigned long> AttributeIndexVector;

} // end vsim

#endif
