#include <sys/time.h>
#include <time.h>
#include "task.h"
#include "vsimstore.h"
#include "vsimseeder.h"

namespace vsim {

VSimSeeder::VSimSeeder(VSimStore &store, docid_t start, docid_t end, int which)
    : _store(store),
      _start(start),
      _end(end),
      _whichCPU(which),
      _done(2)
{ }

void
VSimSeeder::run(void)
{
    _store.seedRange(time(0), _start, _end);
    _done.wait();
}

void
VSimSeeder::shutdown(void)
{
    _done.wait();
}

bool
VSimSeeder::getPreferredCPU(cpu_set_t &set)
{
    CPU_ZERO(&set);
    CPU_SET((_whichCPU % NUMCPU), &set);
    return (true);
}

} // end vsim
