#ifndef _VSIMSEEDER_H_
#define _VSIMSEEDER_H_

#include "types.h"
#include "vsimstore.h"
#include "task.h"
#include "barrier.h"

namespace vsim {

/**
 * The VSimSeeder task seeds a range of the document store attributes in order
 * to place data close to a local DRAM controller.
 */
class VSimSeeder : public Task {
public:
    typedef boost::shared_ptr<VSimSeeder> SP;
    VSimSeeder(VSimStore &, docid_t, docid_t, int);
    void run(void);
    void shutdown(void);
    bool getPreferredCPU(cpu_set_t &);

private:
    VSimStore &_store;
    docid_t _start;
    docid_t _end;
    int _whichCPU;
    Barrier _done;
};

} // end vsim

#endif
