#ifndef _VSIM_VSIMTIME_H_
#define _VSIM_VSIMTIME_H_
#include <time.h>

namespace vsim {

/**
 * The VSimTime class is a wrapper around the POSIX time keeping classes and
 * provides methods for aquiring the current time as well calculating time
 * difference.
 */
class VSimTime {
public:
    VSimTime();
    VSimTime(struct timeval &);
    void recordTime(void);

    static const unsigned long NANO_PER_MILLI = 1000000;
    static const unsigned long MILLI_PER_SECOND = 1000;
    static const unsigned long NANO_PER_MICRO = 1000;
    static const unsigned long MICRO_PER_SECOND = 1000000;
    unsigned long getTimeSeconds(void);
    unsigned long getTimeMilliSeconds(void);
    unsigned long getTimeNanoSeconds(void);

    unsigned long getDiffMilliSeconds(VSimTime &);
    unsigned long getDiffMicroSeconds(VSimTime &);
private:
    struct timespec _value;
};

} // end vsim

#endif
